<script setup lang="ts">
import { ref } from 'vue'

interface AddressBook {
  id: number
  name: string
  tel: string
  gender: string
}

const address = ref<AddressBook>({
  id: 0,
  name: '',
  tel: '',
  gender: 'Male'
})

let lastId = 1

const addressList = ref<AddressBook[]>([])
const isAddNew = ref(false)

function save() {
  // address.value.id = lastId++
  // addressList.value.push({...address.value, id: lastId++ })
  // address.value={
  //   id: 0,
  //   name: '',
  //   tel: '',
  //   gender: 'Male'
  // }

  if (address.value.id > 0){
    const editedIndex = addressList.value.findIndex((item) => item.id === address.value.id)
    addressList.value[editedIndex] = address.value
  } else {
    addressList.value.push({...address.value, id: lastId++ })
  }
    isAddNew.value = false
    address.value={
    id: 0,
    name: '',
    tel: '',
    gender: 'Male'
  }
}

function edit(id: number) {
  isAddNew.value = true
  const editedIndex = addressList.value.findIndex((item) => item.id === id)
  address.value = JSON.parse(JSON.stringify(addressList.value[editedIndex]))
}

function remove(id: number) {
  const removeIndex = addressList.value.findIndex((item) => item.id === id)
  addressList.value.splice(removeIndex, 1)
}
</script>

<template>
  <div>
    <div v-if="isAddNew">
    <div>
      <label for="name">name:</label>
      <input id="name" type="text" v-model="address.name" />
    </div>
    <div>
      <label for="gender">gender:</label>
      <select id="gender" v-model="address.gender">
        <option value="Male">Male</option>
        <option value="Female">Female</option>
        <option value="Other">Other</option>
      </select>
    </div>
    <div>
      <label for="tel">tel:</label>
      <input id="tel" type="text" v-model="address.tel" />
    </div>
  <button >Clear</button><button @click="save">Save</button>
  <div>
    <pre>{{ address }}</pre>
  </div>
</div>

<button @click="isAddNew = !isAddNew">Add</button>

</div>
  <div>
    <table>
      <th>
        <td>ID</td>
        <td>Name</td>
        <td>Gender</td>
        <td>Tel</td>
      
      <tr v-for="ad of addressList" :key="ad.id">
        <td>{{ ad.id }}</td>
        <td>{{ ad.name }}</td>
        <td>{{ ad.gender }}</td>
        <td>{{ ad.tel }}</td>
        <td><button @click="edit(ad.id)">Edit</button><button @click="remove(ad.id)">Delete</button></td>
      </tr>
    </th>
    </table>
  </div>
</template>

<style scoped>
input,
select,
lable,
button {
  font-family: 'Kanit';
  font-size: 20pt;
  margin: 5px;
}
</style>
